; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include autobutn.inc      ; local includes for this file
      include \masm32\macros\macros.asm

      PushButton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"a_butn_class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                            hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 70, 40

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL bwid  :DWORD
    LOCAL bhgt  :DWORD
    LOCAL bspc  :DWORD
    LOCAL blft  :DWORD
    LOCAL btop  :DWORD
    LOCAL pbuf  :DWORD

    LOCAL Rct   :RECT
    LOCAL buffer1[260]:BYTE
    LOCAL buffer2[260]:BYTE

    Switch uMsg
      Case WM_COMMAND
        cmp wParam, "a"             ; check for button ID in range of "a" to "z"
        jl @F
        cmp wParam, "z"
        jg @F

        mov pbuf, ptr$(buffer1)
        mov eax, pbuf
        mov ecx, wParam
        mov [eax], cl

        mov pbuf, cat$(pbuf,":")
        fn SetCurrentDirectory,pbuf
        invoke GetCurrentDirectory,260,ADDR buffer2
        invoke SetWindowText,hWin,ADDR buffer2

      @@:

      Case WM_CREATE
        push ebx
        push esi
        push edi

        mov btop, 2                 ; button top spacing
        mov bwid, 20                ; button width
        mov bhgt, 20                ; button height
        mov bspc, 4                 ; spacing between buttons

        mov esi, 26                 ; loop "a" to "z"
        mov ebx, 97                 ; 1st drive letter as lower case ascii
        mov edi, bspc

      cblp:
        mov pbuf, ptr$(buffer1)
        mov eax, pbuf
        mov [eax], bl
        mov pbuf, cat$(pbuf,":")
      ; ---------------------------------------------
      ; test for valid drives in the "a" to "Z" range
      ; ---------------------------------------------
        invoke GetDriveType,pbuf    ; 2 to 6 are valid drive types
        cmp eax, 2
        jl nxt
        cmp eax, 6
        jg nxt
      ; ------------------------------------------
      ; ascii drive letter value in EBX is used
      ; as the button ID for WM_COMMAND processing
      ; ------------------------------------------
        fn PushButton,pbuf,hWin,edi,btop,bwid,bhgt,ebx
        add edi, bspc
        add edi, bwid
      nxt:
        add ebx, 1                  ; increment drive letter
        sub esi, 1
        jnz cblp

        pop edi
        pop esi
        pop ebx

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_PAINT
        invoke Paint_Proc,hWin
        return 0

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)

  ; ----------------------------------------

    mov btn_hi, rv(GetSysColor,COLOR_BTNHIGHLIGHT)

    mov btn_lo, rv(GetSysColor,COLOR_BTNSHADOW)

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; 

PushButton proc lpText:DWORD,hParent:DWORD,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

    LOCAL hbutn :DWORD

    szText btnClass,"BUTTON"

    invoke CreateWindowEx,0,
            ADDR btnClass,lpText,
            WS_CHILD or WS_VISIBLE,       ; or BS_FLAT or BS_LEFT
            a,b,wd,ht,hParent,ID,
            hInstance,NULL

    mov hbutn, eax

    fn SendMessage,hbutn,WM_SETFONT,rv(GetStockObject,ANSI_VAR_FONT),TRUE

    mov eax, hbutn

    ret

PushButton endp

; 

end start
